//
//  AccountConfig.h
//  TApp2
//
//  Created by Microfocus on 7/16/15.
//  Copyright (c) 2017 Microfocus. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface AccountConfig : NSObject <NSCoding>

@property (strong, nonatomic) NSMutableDictionary *oauthProps;

- (id) initWithProviderUrl:(NSString *) providerUrl
                       clientId:(NSString *) clientId
                   clientSecret:(NSString *) secret
                    redirectURI:(NSString *) redirectUri
                          scope:(NSString *) scope
                    accountName:(NSString *) acctName;

- (id) initWithAuthzEndpoint:(NSString *) authzUrl
               tokenEndpoint:(NSString *) tokenUrl
            userInfoEndpoint:(NSString *) userinfoUrl
                    clientId:(NSString *) clientId
                clientSecret:(NSString *) secret
                 redirectURI:(NSString *) redirectUri
                       scope:(NSString *) scope
                 accountName:(NSString *) acctName;

- (id) initWithAuthzEndpoint:(NSString *) authzUrl
               tokenEndpoint:(NSString *) tokenUrl
          revocationEndpoint:(NSString *) revocationUrl
            userInfoEndpoint:(NSString *) userinfoUrl
                    clientId:(NSString *) clientId
                clientSecret:(NSString *) secret
                 redirectURI:(NSString *) redirectUri
                       scope:(NSString *) scope
                 accountName:(NSString *) acctName;

- (id) initWithAuthzEndpoint:(NSString *) authzUrl
               tokenEndpoint:(NSString *) tokenUrl
          revocationEndpoint:(NSString *) revocationUrl
            userInfoEndpoint:(NSString *) userinfoUrl
            browserLogoutUrl:(NSString *) browserLogoutUrl
                    clientId:(NSString *) clientId
                clientSecret:(NSString *) secret
                 redirectURI:(NSString *) redirectUri
                       scope:(NSString *) scope
                 accountName:(NSString *) acctName;

- (id) initWithGrantEndpoint:(NSString *) grantUrl
                    clientId:(NSString *) clientId
                clientSecret:(NSString *) secret
                 redirectURI:(NSString *) redirectUri
                       scope:(NSString *) scope
                 accountName:(NSString *) acctName;

- (id) initWithDiscoveryUrl:(NSString *) discoveryUrl
                   clientId:(NSString *) clientId
               clientSecret:(NSString *) secret
                redirectURI:(NSString *) redirectUri
                accountName:(NSString *) acctName;

- (id) initWithDiscoveryUrl:(NSString *) discoveryUrl
         revocationEndpoint:(NSString *) revocationUrl
                   clientId:(NSString *) clientId
               clientSecret:(NSString *) secret
                redirectURI:(NSString *) redirectUri
                accountName:(NSString *) acctName;

- (id) initWithDiscoveryUrl:(NSString *) discoveryUrl
         revocationEndpoint:(NSString *) revocationUrl
           browserLogoutUrl:(NSString *) browserLogoutUrl
                  clientId:(NSString *) clientId
              clientSecret:(NSString *) secret
               redirectURI:(NSString *) redirectUri
               accountName:(NSString *) acctName;

- (NSString *) getAccountName;
- (NSString *) getProviderUrl;
- (NSString *) getAuthzUrl;
- (NSString *) getTokenUrl;
- (NSString *) getRevocationUrl;
- (NSString *) getBrowserLogoutUrl;
- (NSString *) getGrantUrl;
- (NSString *) getUserinfoUrl;
- (NSString *) getClientId;
- (NSString *) getClientSecret;
- (NSString *) getScope;
- (NSString *) getRedirectUri;
- (NSString *) getProviderDomain;
- (NSString *) getDiscoveryUrl;

- (void)       setOAuthDone:(NSString *) oauthDone;
- (BOOL)       isOAuthDone;
- (NSString *) getTestPR1;
- (void) setTestPR1:(NSString *) testpr;

- (Boolean) saveAccountConfig;
+ (AccountConfig *) loadAccountConfig;
- (Boolean) removeAccountConfig;

@end
