//
//  ViewController.h
//  TApp2
//
//  Created by Microfocus on 2/16/17.
//  Copyright © 2017 Microfocus. All rights reserved.
//

#import <UIKit/UIKit.h>

#import <MFAuthLib/MFServiceConfiguration.h>

@class MFAuthService;

NS_ASSUME_NONNULL_BEGIN

@interface ViewController : UIViewController
@property (weak, nonatomic) IBOutlet UIButton *deleteConfigButton;
@property(nullable) IBOutlet UIButton *authAutoButton;
@property(nullable) IBOutlet UIButton *authManual;
@property(nullable) IBOutlet UIButton *codeExchangeButton;
@property(nullable) IBOutlet UIButton *userinfoButton;
@property(nullable) IBOutlet UIButton *clearAuthStateButton;
@property(nullable) IBOutlet UITextView *logTextView;

/*! @brief The authorization state. This is the AppAuth object that you should keep around and
 serialize to disk.
 */
//@property(nonatomic, readonly, nullable) OIDAuthState *authState;

@property(nonatomic, readonly, nullable) MFAuthService *authService;

/*! @brief Authorization code flow using @c OIDAuthState automatic code exchanges.
 @param sender IBAction sender.
 */
- (IBAction)authWithAutoCodeExchange:(nullable id)sender;

/*! @brief Authorization code flow without a the code exchange (need to call @c codeExchange:
 manually)
 @param sender IBAction sender.
 */
- (IBAction)authNoCodeExchange:(nullable id)sender;

/*! @brief Performs the authorization code exchange at the token endpoint.
 @param sender IBAction sender.
 */
- (IBAction)codeExchange:(nullable id)sender;

/*! @brief Performs a Userinfo API call using @c OIDAuthState.performActionWithFreshTokens.
 @param sender IBAction sender.
 */
- (IBAction)userinfo:(nullable id)sender;

/*! @brief Nils the @c OIDAuthState object.
 @param sender IBAction sender.
 */
- (IBAction)clearAuthState:(nullable id)sender;

/*! @brief Clears the UI log.
 @param sender IBAction sender.
 */
- (IBAction)clearLog:(nullable id)sender;

@end

NS_ASSUME_NONNULL_END

